// ---------------------------------------------------------------------- \\
// ------------- Zooming and time paning control ------------------------ \\
// ---------------------------------------------------------------------- \\
// *
// MAIN VARIABLES AND SWITCHES
// - - - - - zooming | panning | dates - - - - - - 
float zoom = 1; // By default we se everything, but this can be scaled up to 3. Or even 4 maybe? Perhaps changin this value at the beginning could animate it
float zoomD = 2;
float fecha1 = 1900; // Starting date of our viz... // Watch out, because this dates are not only for the "visual"
float fecha2 = 2015; // Finishing date of our viz... // This dates are used to load the yearly NGrams and NYTimes data
float zoomFriccion = 7; // 19 works
// - - - - - timeline - - - - - - - - - - -
float timeLineY = (alto/4) *3; 
float timeLineCenter = 1910;// Specified DATE in years (could be any year to start), this variable controls all graphics!
float timeLineCenterD = 1910;
float timeLineCenterFriccion = 5;
float timeLineHeight = 25;
//
// * friction and other veriables
// 
// ----------------------------------------------------------------------------------------------------------------
// Controls zooming and paning
void zooming() {

  // 1. We calculate the actual zoom
  if (zoom != zoomD) zoom = calcularFriccion( zoom, zoomD, zoomFriccion );

  // 2. We calculate the timeline Values
  if ( timeLineCenter != timeLineCenterD ) timeLineCenter = calcularFriccion( timeLineCenter, timeLineCenterD, timeLineCenterFriccion );
}
// ----------------------------------------------------------------------------------------------------------------
// This function will display the timeline at the middle of our stage (always visible, always present)
void timeLine() {

  // 1. We draw the timeline's rectange
  noStroke();
  fill(red(blanco), green(blanco), blue(blanco), 3); 
  shapeMode(CENTER);
  shape( Rect, width/2, timeLineY, width, timeLineHeight);

  // 2. We draw the TimeLine Center Position
  noFill();
  strokeWeight(0.5);
  stroke(blanco);
  float altoTimeLineCenter = timeLineHeight+1;
  float timeLineActualXCenter = map(timeLineCenter, fecha1, fecha2, 0, width);
  line( timeLineActualXCenter, timeLineY, timeLineActualXCenter, timeLineY+altoTimeLineCenter);
  line( timeLineActualXCenter, timeLineY, timeLineActualXCenter, timeLineY-altoTimeLineCenter);
  shapeMode(CENTER);
  fill(blanco);
  noStroke();
  shape( Ellipse, timeLineActualXCenter, timeLineY+altoTimeLineCenter, 4, 4);
  shape( Ellipse, timeLineActualXCenter, timeLineY-altoTimeLineCenter, 4, 4);

  // 3. We draw the mouse indicator (only if it is still in position)
  if (timeLineHit(mouseY)) {
    // a. Drawing properties
    noStroke();
    fill(red(blanco), green(blanco), blue(blanco), 80);

    // b. Actual drawing
    shapeMode(CENTER);
    shape( Rect, mouseX, timeLineY, 10, timeLineHeight );
  }

  //4. We draw the dates
  int cantidadFechas = 15;
  for ( int i = 0; i < cantidadFechas*3 +1; i++ ) {
    // We specify a temporary value
    float interDate = width/(cantidadFechas*3);
    float xDate = i*interDate;

    if (i%3 == 0) { // 4-1 We draw the date
      //
      int valor = floor(map(xDate, 0, width, fecha1, fecha2)); // We see which year we want
      textFont(avenirMedium, 8);
      textAlign(CENTER);
      fill(red(blanco), green(blanco), blue(blanco), 190);
      noStroke();
      text( valor, xDate, timeLineY+3);
    } else { // 4-2 We draw a line
      strokeWeight(random(0.5, 0.51));
      stroke(red(blanco), green(blanco), blue(blanco), 80);
      //stroke(blanco);
      line(xDate, timeLineY, xDate, timeLineY+(timeLineHeight/8) );
      line(xDate, timeLineY, xDate, timeLineY-(timeLineHeight/8) );
    }
  }
  
  
}
// ----------------------------------------------------------------------------------------------------------------
// This functions checks if the mouse cursor is above the timeline
Boolean timeLineHit( float y) {  
  // 1. A variable to store values
  Boolean hicimosHit = false;  
  // 2. We check if we are within the height
  if ( y > timeLineY-( timeLineHeight/2 ) && y < timeLineY+(timeLineHeight/2) ) {
    hicimosHit = true;
  }
  // 3. We return the variable
  return hicimosHit;
}

// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
