// ------------------------------------------------------------------ \\
// ------------- G R A L - f u n c t i o n s ------------------------ \\
// ------------------------------------------------------------------ \\
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ SIZE properties
// -----------------------------------------------------------------------------------------------> size properties
void sizeProperties() {
  // 1. We setup the width and height
  if (fullscreen) ancho = displayWidth;
  if (fullscreen) alto = displayHeight;

  // 3. We restart the variables that need to be restarted
  timeLineY = (alto/4) *3;

  // 2. We setup the size
  size(ancho, alto, P2D);
  background(azul3);
}
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ SHAPE works
// -----------------------------------------------------------------------------------------------> shapes
PShape Rect, Line, Ellipse, Punto; // Same function as Processing but with a CAPITAL letter, huh? 
// * 
void loadShapes() {
  // RECT, ELLIPSE AND LINE SHAPE
  Rect = createShape(RECT, 0, 0, 8, 8);
  Ellipse = createShape(ELLIPSE, 0, 0, 8, 8);
  crearPunto(); // We'll create a point differently

  // We disable all the styles
  Rect.disableStyle(); 
  Ellipse.disableStyle();
  Punto.disableStyle();
}

void crearPunto() {
  Punto = createShape();
  Punto.beginShape();
  Punto.vertex(0, 0);
  Punto.vertex(0, 2);
  Punto.vertex(2, 2);
  Punto.vertex(2, 0);
  Punto.vertex(0, 0);
  Punto.endShape();
}
// ----------------------------------------------------------------------------------------------
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ Friction Calculation
float calcularFriccion(float actual, float deseo, float coeficiente) {

  // 0. Local variables we'll use
  float intervalo = 0;
  float resultado = 0.0;

  // 1. We check which value is bigger
  if (actual > deseo) intervalo = actual - deseo;
  if (deseo > actual) intervalo = deseo - actual;

  // 2. We calculate the friction operations
  intervalo /= coeficiente;

  // 3. We add all of the data
  if (intervalo > 0.0000001) {
    if (actual > deseo) resultado = actual - intervalo;
    if (deseo > actual) resultado = actual + intervalo;
  } else {
    resultado = deseo;
  }

  // 4. We return the number
  return resultado;
}

// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓  FONTS

// ----------------------------------------------------------------------------------------------
PFont avenirBook, avenirMedium, avenirMediumBig, avenirBlack, avenir, avenirHeavy, avenirMediumSmall, avenirTitle1, avenirTitle2, avenirTops, avenirDemiBold;
PFont avenirRegular, avenirBookYear;
PFont avenirNextMedium, avenirNextUltraLight;
void loadFonts() {

  // Normal Avenir (book)
  avenirBook = createFont("DATA/FONTS/Avenir-Book.ttf", 18);
  // For the year detail view
  avenirBookYear = createFont("DATA/FONTS/Avenir-Book.ttf", 34);
  // Tops Avenir
  avenirTops = createFont("DATA/FONTS/Avenir-Book.ttf", 11);
  // Medium Avenir
  avenirMediumSmall = createFont("DATA/FONTS/Avenir-Medium.ttf", 8);
  // Medium Avenir
  avenirMedium = createFont("DATA/FONTS/Avenir-Medium.ttf", 18);
  // Medium Avenir
  avenirMediumBig = createFont("DATA/FONTS/Avenir-Medium.ttf", 67);
  // Black Avenir
  avenirBlack = createFont("DATA/FONTS/Avenir-Black.ttf", 18);
  // Black Avenir
  avenirTitle1 = createFont("DATA/FONTS/Avenir-Black.ttf", 9);
  // Black Avenir
  avenirTitle2 = createFont("DATA/FONTS/AvenirNext-UltraLight.ttf", 10);
  // Heavy Avenir
  avenirHeavy = createFont("DATA/FONTS/Avenir-Heavy.ttf", 18);
  // OTF avenir
  avenir = createFont("DATA/FONTS/avenir.otf", 8);
  // Demi Bold
  avenirDemiBold = createFont("DATA/FONTS/AvenirNext-DemiBold.ttf", 14);
  // Regular
  avenirRegular = createFont("DATA/FONTS/AvenirNext-Regular", 14);
  // Next Medium
  avenirNextMedium = createFont("DATA/FONTS/AvenirNext-Medium.ttf", 23);
  // Next UltraLight
  avenirNextUltraLight = createFont("DATA/FONTS/AvenirNext-UltraLight.ttf", 23);
}
// ----------------------------------------------------------------------------------------------
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ Sorting HAT

// This Class is used to make the alternate fillings of an specific graphic --------------
class SortingHat {
  // A. Properties
  Boolean artistPrendido = false;
  Boolean musicianPrendido = false;
  Boolean technicianPrendido = false;
  Boolean topicPrendido = false;
  Boolean writerPrendido = false;
  String tiposPrendidosT = ""; // 
  String [] tiposPrendidos;
  int totalesPrendidos = 0; // Very important to see how many are turned on
  int totales = 0;
  String [] positionsTipo; // the arrays we will actually return
  int [] positionsNo;

  // B. Constructores
  SortingHat(String combinacion) {

    // We check which types are turned on and which ones not
    revisarPrendidos(combinacion);
    // How many items we have in total
    revisarTotales();
    // Now we realize the sorting
    realizarSorting();
  }

  // -----------------------------------------
  void revisarPrendidos(String quienes) {
    // Quienes activaton order ARTIST(1) MUSICIAN(2) TECHNICIAN(3) TOPIC(4) WRITER(5)
    // 1. We check who is activated and who is not
    if ((quienes.charAt(0)) == '1') {
      artistPrendido = true;
      tiposPrendidosT += "artists,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(1)) == '1') {
      musicianPrendido = true;
      tiposPrendidosT += "musicians,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(2)) == '1') {
      technicianPrendido = true;
      tiposPrendidosT += "technicians,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(3)) == '1') {
      topicPrendido = true;
      tiposPrendidosT += "topics,";
      totalesPrendidos++;
    }
    if ((quienes.charAt(4)) == '1') {
      writerPrendido = true;
      tiposPrendidosT += "writers,";
      totalesPrendidos++;
    }
    //2. We divide the tipos String
    tiposPrendidos = split(tiposPrendidosT, ","); // The names of all types
  }
  // -------------------------
  void revisarTotales() {
    // 1. Depending on the datasets desired, we will select the quantities
    if (artistPrendido) totales += artists;
    if (musicianPrendido) totales += musicians;
    if (technicianPrendido) totales += technicians;
    if (topicPrendido) totales += topics;
    if (writerPrendido) totales += writers;
  }
  // --------------------------
  void realizarSorting() {

    // I. We will create a helper filling arrays
    String [] tiposHelpers = new String[totalesPrendidos];
    int [] totalesHelpers = new int[totalesPrendidos];
    int [] actualesHelpers = new int[totalesPrendidos];
    Boolean [] yaTerminadosHelpers = new Boolean[totalesPrendidos];

    // I. We will fill these helper arrays

    for (int i = 0; i < totalesPrendidos; i++) {
      // Tipos
      tiposHelpers[i] = tiposPrendidos[i]; // This array was declared earlier in the function
      //println(">> CREATING A NEW TIPO >> "+tiposHelpers[i]);
      // Totales
      if (tiposHelpers[i].equals("artists")) totalesHelpers[i] = artists;
      if (tiposHelpers[i].equals("musicians")) totalesHelpers[i] = musicians;
      if (tiposHelpers[i].equals("technicians")) totalesHelpers[i] = technicians;
      if (tiposHelpers[i].equals("topics")) totalesHelpers[i] = topics;
      if (tiposHelpers[i].equals("writers")) totalesHelpers[i] = writers;
      // Actuales
      actualesHelpers[i] = 0;
      // Ya terminados
      yaTerminadosHelpers[i] = false;
    }

    // II. We will now use declare the actual arrays we'll fill to display an alternate thing  THIS ARE THE ARRAYS WE WILL RETURN
    positionsTipo = new String[totales]; // We'll save the types here
    positionsNo = new int[totales]; // We'll save the numbers to each array position here
    Boolean yaTodos = false;

    // XX IV. And now the delicate function, the alternate array filling function
    int contadorGlobal = 0;
    //println(">> Alternate filling function");
    for (int i = 0; yaTodos == false; i++) { // This will execute as long as we haven't finished up fillinf
      // IV - 1 We determine the modulo we'll use
      int modulo = totalesPrendidos;

      // IV - 2 We will start to fill it now
      if (!yaTerminadosHelpers[i%modulo]) {

        // We set the new values
        positionsTipo[contadorGlobal] = tiposHelpers[i%modulo];
        positionsNo[contadorGlobal] = actualesHelpers[i%modulo];

        // We add the actual type counter and the global one
        actualesHelpers[i%modulo]++;
        contadorGlobal++;

        // Let's ask if this type has already been filled
        if (actualesHelpers[i%modulo] >= totalesHelpers[i%modulo]) yaTerminadosHelpers[i%modulo] = true;
      }

      // IV - 4 Let's check if we've finished with all of them
      int contadorTotalesPrendidos = 0;
      for ( int j = 0; j < totalesPrendidos; j++ ) {
        if ( yaTerminadosHelpers[j]) contadorTotalesPrendidos++;
      }
      if (contadorTotalesPrendidos >= totalesPrendidos) yaTodos = true;
    }
  }

  // C. Getters/Setters (Very important, this is how we access the data) ------------------------
  String [] getPositionsTipo() {
    return positionsTipo;
  }
  int [] getPositionsNo() {
    return positionsNo;
  }
  int getTotales() {
    return totales;
  }
  // Class ends next --->
}



// ----------------------------------------------------------------------------------------------
// This function controls play along the sketch
Boolean enReproduccion = false;
void playFunction() {
  // We ask if we can go on
  float intervaloAumento = 0.025; // How fast
  if (timeLineCenter < fecha2-intervaloAumento) {
    timeLineCenterD += intervaloAumento;
  } else {
    timeLineCenterD = fecha1;
  }
}

// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ String Splitting

// ------------------------------------------------------------------------- the Function
String [] separarTexto(String texto, Boolean dividir) {
  // 1. We always start in the first point
  int posicionArreglo = 0;

  // 2. We establish the length of our text
  int longitud = texto.length();

  // 3. We create a new Array where to put everything
  String [] letras = new String[longitud];
  letras[0] = "";
  letras[1] = "";

  // 4. We cycle through the Array
  int contPalabraActual = 0;
  int limiteCaracteres = 7;
  for (int i = 0; i < longitud; i++) {
    if (texto.charAt(i) == ' ') {
      posicionArreglo++;
      contPalabraActual = 0;
    } else {
      contPalabraActual++;
      if (dividir) {
        if (contPalabraActual < limiteCaracteres ) letras[posicionArreglo] += texto.charAt(i);
        if (contPalabraActual == limiteCaracteres) letras[posicionArreglo] += ".";
      } else {
        letras[posicionArreglo] += texto.charAt(i);
      }
    }
  }
  // 5. We return the data
  return letras;
}
// -----------------------------------------------------------------------
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ PDF

Boolean deboIniciarPDF = false;
Boolean deboTerminarPDF = false;

// PDF Recording functions
void iniciarPDF() {
  beginRecord( PDF, "CAPTURES/PDF/Rise_And_Fall_"+year()+""+month()+""+day()+"_"+hour()+""+minute()+""+second()+".pdf" );
  deboIniciarPDF  = false;
  deboTerminarPDF = true;
}
void terminarPDF() {
  deboTerminarPDF = false;
  endRecord();
}

// -------------------------------------------------------------------------
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ TYPE WORKS

void typography() {
  // timeLineY Nos determina la posici'on, no olvidarlo

  // ----------------------------------------------------------------------------------------------------------- Main Year
  // 1. We determine the y position
  float alturaAnoPrincipal = timeLineY+110;

  //2. We put the year there
  textFont( avenirMediumBig, 67 ); // Disponible book black heavy
  fill(red(blanco), green(blanco), blue(blanco), 160);
  text(int(timeLineCenter), width/2, alturaAnoPrincipal );

  // ----------------------------------------------------------------------------------------------------------- Viz Title #nwmd
  // 1. We specify the values
  String title1 = "N · e · w  |  M · e · d · i · a  |  R · i · s · e  |  a · n · d    f · a · l · l";
  String title2 = "·  ·  · N · e · w  |  M · e · d · i · a ·  ·  ·";
  String title3 = "R · i · s · e  |  a · n · d  |  f · a · l · l";

  // 2. Title position
  float titleY1 = alturaAnoPrincipal + 28;
  float titleY2 = titleY1+17;



  // 4. We put the text (finally)
  fill(red(blanco), green(blanco), blue(blanco), 100);
  textFont(avenirTitle1);
  textAlign(CENTER);
  text( title2.toUpperCase(), width/2, titleY1 );
  //fill(red(blanco), green(blanco), blue(blanco), 100);
  fill(blanco);
  textFont(avenirTitle1);
  text( title3.toUpperCase(), width/2, titleY2 );
}


// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ COLORS per category
// 1. This function will return the color per category
color obtenerColor(String tipo) {
  // 1. a random color
  color c = color(0, 0, 0);

  // 2. We evaluate the type and return a color
  if (tipo.equals("artists")) {
    c = (amarillo);
  } else if (tipo.equals("topics")) {
    c = (azul1);
  } else if (tipo.equals("technicians")) {
    c = (rojo);
  } else if (tipo.equals("musicians")) {
    c = (naranja);
  } else if (tipo.equals("writers")) {
    c = (azul2);
  }

  // 3. we return the color
  return c;
}

// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ Loaded in every scenario (almost)

void timeLineAndTitle() {
  // We draw the Timeline
  timeLine();

  // We ddraw additional typography elemments
  typography();
}
