// ----------------------------------------------------------- \\
// ------------- i n t e r a c t i o n ------------------------ \\
// ------------------------------------------------------------ \\
// •••••••••••••••••• This tab also has button related options/actions  (bottom )••••••••••••••••••
void keyPressed() {

  // ----------------------------- G L O B A L ----------------------------------------------------
  if (key == 's') save( "CAPTURES/BITMAPS/Rise_And_Fall_"+year()+""+month()+""+day()+"_"+hour()+""+minute()+""+second()+".tiff" );
  // ------------------------------- S K E T C H   C O N T R O L------------------------------------ 
  if (key == '1') {
    timeLineCenterD = 1957; // So it centers the frame
    zoomD = 1;
  }
  if (key == '2') zoomD = 4;
  if (key == '3') zoomD = 17;
  // TESTING MINI AND HUGE MAPS MODES: 
  if (key == '6') hugeMapMode = "NYTimes";
  if (key == '7') hugeMapMode = "NGram";
  if (key == '8') miniMapMode = "NYTimes";
  if (key == '9') miniMapMode = "NGram";
  //if (keyCode == ENTER || keyCode == RETURN) {
  if (keyCode == ' ') {
    enReproduccion = !enReproduccion;
  }
  if (key == 'p') deboIniciarPDF = true;
  // SPECIAL KEYS -------------------------
  if (key == CODED) {
    int intervaloAumento = 1;
    if (keyCode == RIGHT) {
      if (timeLineCenter < fecha2-intervaloAumento) timeLineCenterD += intervaloAumento;
      if (timeLineCenterD >= fecha2) timeLineCenterD = fecha2; // FAILSwitch cause otherwise, the sketch will crash!
    }
    if (keyCode == LEFT) {
      if (timeLineCenter > fecha1+intervaloAumento) timeLineCenterD -= intervaloAumento;
      if (timeLineCenterD <= fecha1) timeLineCenterD = fecha1; // FAILSwitch cause otherwise, the sketch will crash!
    }
  }
  // SCENARIO CHANGE TESTS ----------------
  if (key == 'M') iniciarTransicion("minority report"); // Minority report
  if (key == 'T') iniciarTransicion("tenori on"); // Tenori ON
  if (key == 'F') iniciarTransicion("full huge graph"); // Full Huge Graph
  if (key == 'O') iniciarTransicion("4 tops"); // Tops
}

// --------------------------------------------------------------------------------------------------------------------------------------------
// ********************************************************************************************************************************************
// --------------------------------------------------------------------------------------------------------------------------------------------

void mousePressed() {

  if (timeLineHit(mouseY)) {
    timeLineCenterD = map(mouseX, 0, width, fecha1, fecha2); 
    println(">> NEW DATE: "+floor(timeLineCenterD));
  }
}
// --------------------------------------------------------------------------------------------------------------------------------------------
// ********************************************************************************************************************************************
// --------------------------------------------------------------------------------------------------------------------------------------------

//
//•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
//••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Button related operations
//•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
//•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
// Must be a global variable, why not !!! ???
int fallOff = 0; // Protection for multiple clics
int fallOffLimit = 10; // (usually works, perhaps even more) 50 was before, but it was just too much
// A very simple function will verify if the mouse is within an specific range
Boolean hiceHit( float cx1, float cy1, float cx2, float cy2 ) {
  Boolean respuesta = false;
  if (mouseX > cx1 && mouseX < cx2 && mouseY > cy1 && mouseY < cy2) respuesta = true;
  return respuesta;
}
//•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••

void closeButton() {
  // 1. Fijamos dimensiones
  float tamanoBoton = 5;
  float margenBoton = 15;
  // 2. Trasladamos
  //pushMatrix();
  //translate( width -margenBoton -(tamanoBoton/2), 0 +margenBoton +(tamanoBoton/2) );
  float x = width -margenBoton -(tamanoBoton/2);
  float y = 0 +margenBoton +(tamanoBoton/2);

  // 3. Propiedades de dibujo
  fill(blanco);
  stroke(red(blanco), green(blanco), blue(blanco), 20);
  strokeWeight(2.5);
  if (escenarioActual == "detail view") stroke(red(azul3), green(azul3), blue(azul3), 60);
  // 4. Le hacemos un boton
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( x-tamanoBoton-10, y-tamanoBoton-10, x+tamanoBoton+10, y+tamanoBoton+10 )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    stroke(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      stroke(azul3); // White press
      exit();

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••

  // 5. Dibujamos la cruz
  line(x-tamanoBoton, y-tamanoBoton, x+tamanoBoton, y+tamanoBoton);
  line(x-tamanoBoton, y+tamanoBoton, x+tamanoBoton, y-tamanoBoton);
  //ellipse(0, 0, 3, 3);

  // Fin.
  //popMatrix();
}

// ----------------------------------------------------------------------------------------------------------------------
// This will show the buttons between the  FULL VIEW  /  TOP LIST / WIDE VIEW
void mostrarNavegacion() {
  // 1. Coordinates  --------------------------------------------------------------------
  float xBot = width/2 +40; // THis 80 is to compensate because at the beginning we wanted a 3 button nav
  float yBot = 20;
  float altoNavegacion = 16;
  float toleranciaHit = 9;
  // -----------------------------------------------------------------------------------------------------------------------------------
  // 2. The TOP LIST BUTTON ------------------------------------------------------------- 
  float anchoTopButton = 80 ;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( xBot-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBot+(anchoTopButton/2), yBot+(altoNavegacion/2)+toleranciaHit )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("4 tops");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //rect(xBot, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANG:E
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> TOP LIST <", xBot-(anchoTopButton*0), yBot+3);

  // -----------------------------------------------------------------------------------------------------------------------------------
  // 3. The WIDE VIEW BUTTON -------------------------------------------------------------
  anchoTopButton = 80;
  float xBotW = xBot + anchoTopButton;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( xBotW-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotW+(anchoTopButton/2), yBot+(altoNavegacion/2)+toleranciaHit )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);


    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("full huge graph");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  // rect(xBotW, yBot, anchoTopButton, altoNavegacion); // TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> WIDE VIEW <", xBotW-(anchoTopButton*0), yBot+3);

  // -----------------------------------------------------------------------------------------------------------------------------------
  // 3. The FULL VIEW BUTTON ------------------------------------------------------------- "Minority report"
  anchoTopButton = 80;
  float xBotF = xBot - anchoTopButton;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( xBotF-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotF+(anchoTopButton/2), yBot+(altoNavegacion/2 )+toleranciaHit)) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("minority report");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //rect(xBotF, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> FULL VIEW <", xBotF-(anchoTopButton*0), yBot+3);
  
  // -----------------------------------------------------------------------------------------------------------------------------------
  // 4. The TENORI BUTTON ------------------------------------------------------------- ""tenori on"
  anchoTopButton = 80;
  float xBotN = xBot - anchoTopButton*2;
  // Testing rectangle
  noFill();
  stroke( blanco );
  rectMode(CENTER);
  fill(red(blanco), green(blanco), blue(blanco), 70);
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( xBotN-(anchoTopButton/2), yBot-(altoNavegacion/2)-toleranciaHit, xBotN+(anchoTopButton/2), yBot+(altoNavegacion/2 )+toleranciaHit)) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    fill(blanco); // full Hover color
    if (escenarioActual == "detail view") stroke(azul3);

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      fill(azul3); // White press
      iniciarTransicion("tenori on");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
 // rect(xBotN, yBot, anchoTopButton, altoNavegacion); // TRUE TEST RECTANGLE
  // Finally the text
  textAlign(CENTER);
  textFont(avenirMedium, 9);
  text("> SPLIT NGRAM <", xBotN-(anchoTopButton*0), yBot+3);
}
