// ----------------------- The image reader ------------------------------------ \\ 

// *
int categoriasMaximas = 5; // Since we have: artists, writers, topics, technicians
int slicesX = 400;
int slicesY = 100;
String [] nombreCat = {
  "artists", "technicians", "topics", "writers", "musicians"
};
// *
int categoria = 0;
float [] puntosViz = new float[slicesX];
String puntos = "";
int itemActual = 0;
int itemsTotales, itemGlobal;
String nombreItem;
void parsing() {

  // We specify the current data
  if (categoria == 0 ) { // ----------- ARTISTS
    itemsTotales = artists;
    nombreItem = artistNombre[itemActual];
  } else if (categoria == 1 ) { // ---- TECHNICIANS
    itemsTotales = technicians;
    nombreItem = technicianNombre[itemActual];
  } else if (categoria == 2 ) { // ---- TOPICS
    itemsTotales = topics;
    nombreItem = topicNombre[itemActual];
  } else if (categoria == 3 ) { // ---- WRITERS
    itemsTotales = writers;
    nombreItem = writerNombre[itemActual];
  }
  else if (categoria == 4 ) { // ------ MUSICIANS
    itemsTotales = musicians;
    nombreItem = musicianNombre[itemActual];
  }

  // We establish the total items
  PImage pic = loadImage("DATA/NGRAMS/"+nombreCat[categoria]+"/"+nombreItem+".png"); 

  // 0. We place the image and identify blue color (only once), We learned that blue is: -12356384
  //image(pic, 0, 0, width, height);
  //println(">> COLOR >> "+pic.get(mouseX, mouseY));

  // 2. We start to parse, according to the slices
  for (int i = 0; i < slicesX; i++) {

    // a. We specify the point of our slice
    int sliceX = floor(map( i, 0, slicesX, 1, pic.width ));

    // b. We search for blue color
    int encontrado = slicesY;
    for ( int j = 0; j < slicesY; j++ ) {      
      // i. A point within height
      int sliceY = floor(map(j, 0, slicesY, 1, pic.height));

      // ii. We get the color
      if ( pic.get(sliceX, sliceY) == -12356384) {
        encontrado = j;
      }
    }

    // c. We scale the found value
    float encontradoAjustado = map( encontrado, 0, slicesY, 0, 1 );

    // d. we add the found value into the array
    puntosViz[i] = (encontradoAjustado*1);
    puntos += (encontradoAjustado*1)+",";
  }

  //3. we save it and close the sketch
  // We transalte everything to Strings
  String [] puntosT = split(puntos, ",");
  saveStrings("SAVED_SEARCHES/NGRAMS_points/"+nombreCat[categoria]+"/"+nombreItem+".txt", puntosT);

  //4. Just a graphic display test 
  for (int i = 0; i < slicesX; i++) {

    float x = map(i, 0, slicesX, 0, width);
    //float y = map(puntosViz[i], 0, 1, 0, height);
    float y = map(float(puntosT[i]), 0, 1, 0, height);
    noStroke();
    fill(75, 193, 255);
    ellipse(x, y, 3, 3);
   
  }

  // 5. Sequential operators
  itemActual++;
  itemGlobal++;
  puntos = "";
  if (itemActual >= itemsTotales) {
    itemActual = 0;
    categoria++; 
    if (categoria >= categoriasMaximas) {
      exit(); //We close the sketch
    }
  }

  // Function ends
}

