// **************************************************
// ** TIME CONTROL **********************************
// **************************************************
// 
//
// VARS ->
int segundoActual, segundoAnterior;
int callsVigentesEnEsteSegundo = 0;
Boolean queryPermitida = true;
// --------------------------------------------------------- 

void iniciarTiempo() {
  // We start the time, nothing else to see here folks.
  segundoActual = floor(millis()/1000);
  segundoAnterior = floor(millis()/1000);
}
// --------------------------------------------------------- 

void verificarTiempo() {

  // 1. Vemos cual es el actual
  segundoActual = floor(millis()/1000);

  // 2. Verificamos si es el mismo
  if (segundoActual != segundoAnterior) {
    //Reiniciamos el tiempo
    segundoAnterior = segundoActual;

    // Reiniciamos las calls
    callsVigentesEnEsteSegundo = 0;
  }

  // 3. Preguntamos si podemos hacer una call
  if (callsVigentesEnEsteSegundo <= callsPorSegundo ) {

    // Permitimos la query
    queryPermitida = true;
  } else {
    // No permitimos la Query
    queryPermitida = false;
  }
 
 
 //println(" * * * TIME > > "+segundoActual+"|"+segundoAnterior+" > > calls on this second: "+callsVigentesEnEsteSegundo);
}

// --------------------------------------------------------------------------------------------------------

void  loadingBar() {

  // 1. Erase everything
  background(240);

  // 2. We adjust the size
  float tamano = map( busquedaActual, 0, busquedasTotales, 0, width );

  // 3. We draw the rectangle
  rectMode(CORNERS);
  fill(255, 0, 0);
  noStroke();
  rect(0, 0, tamano, height);

  // 4. We draw the individual progress rectangle (sometimes, somehow it won't work)
  tamano = map(itemActual, 0, itemsTotales, 0, width);
  fill(79, 222, 69);
  noStroke();
  
  // 5. Size adjustment for segmented mode (just in case)
  if(segmentedMode) tamano = map(fechaActual, fechaMinima, fechaMaxima, 0, width);
  rect(0, height/4 *3, tamano, height);
}
