// ----------------------------------------------------------- \\
// -------------  C O V E R ----------------------------------- \\
// ------------------------------------------------------------ \\

// The cherry at the top of the cake, our cover in motion
float alphaLetrasCover = 0;
int sentidoAlphaLetrasCover = 1;
void cover() {

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ WIDESCREEN BARS
  // 1. We show the waves
  for (int i = 0; i < cantidadOlas; i++) {
    fondo[i].mostrar();
  }

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ WIDESCREEN BARS
  // 1. TOP Bar
  noStroke();
  fill(azul3);
  rectMode(CORNER);
  rect(0, 0, width, height/4);

  // 2. Bottom bar
  rectMode(CORNER);
  rect(0, height/4 *3, width, height/4);


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ MAIN TITLE
  // 1. We put the title
  /*
  // Test full text
   fill(blanco);
   textFont(avenirRegular, 23);
   textAlign(CENTER);
   String tituloPrincipal = "N · E · W     M · E · D · I · A     R · I · S · E     A · N · D     F · A · L · L";
   text(tituloPrincipal, width/2, height/2);
   
   */
  textFont(avenirNextUltraLight, 23);
  fill(blanco);
  textAlign(RIGHT);
  text("N · E · W     M · E · D · I · A", width/2 -60, height/2);
  textFont(avenirNextMedium, 23);
  textAlign(LEFT);
  text("R · I · S · E     A · N · D     F · A · L · L", width/2 -29, height/2);


  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ LEGEND CLICK ANYWHERE and Credits
  // 1. We put the text
  fill(red(blanco), green(blanco), blue(blanco), alphaLetrasCover);
  textFont(avenirNextMedium, 13);
  textAlign(CENTER);
  text(" > click to start < ", width/2, height-90); 

  // 2. We calculate the alpha
  alphaLetrasCover += 3.6 * sentidoAlphaLetrasCover;
  if (alphaLetrasCover > 255) sentidoAlphaLetrasCover = -1;
  if (alphaLetrasCover < 0) sentidoAlphaLetrasCover = 1;
  
  // 3. 
  fill(red(blanco), green(blanco), blue(blanco), 60);
  textFont(avenirBook, 12);
  textAlign(CENTER);
  String credits = "Idea and code by JM Escalante | Media Arts & Technology - UCSB | MMXV";
  text(credits, width/2, height-35);

  // █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ HUGE INVISIBLE BUTTON!!!!
  // 1. We just put the button and that's it
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••• Rect Button ••••••••••   ( x )
  if ( hiceHit( 0, 0, width, height )) { // Ese +10 es tolerancia

    // 1. MOUSE OVER DRAW ATTRIBUTES
    // stroke(blanco); // full Hover color

    // 2. ACTION AFTER HIT
    if (mousePressed && fallOff == 0) {

      // After the cover we start with the minority report view
      iniciarTransicion("minority report");

      fallOff = fallOffLimit;
    } 
    // 3. FALL OFF OPERATIONS (ignore)
    // FallOff Operations, highly important!
    fallOff -= 1;
    if (fallOff <= 0) fallOff = 0; // So we don't get negative values
  } // <-- Button iF
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  //•••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••••
  // Cover scenario ends next --->
}

// -----------------------------------------------------------------------------------------------------------------------

// -----------------------------------------------------------------------------------------------------------------------
// Here we will start the class
int cantidadOlas = 30;
Ola [] fondo;
void startCover() {

  // 1. Temporary Array
  Ola [] fondoT = new Ola[cantidadOlas];

  //2. We fill it
  for (int i = 0; i < cantidadOlas; i++) {
    fondoT[i] = new Ola();
  }

  // 3. Lo igualamos
  fondo = fondoT;
}

// --------------------------------------------------------------------------------------------------------------------
// A special class11
class Ola {
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
  // Properties
  float elementosMin = 4; //3 worked
  float elementosMax = 29; // 23 worked
  float ruidoMin = 0.000002;
  float ruidoMax = 0.0024;
  float alturaMax = 400;
  float alturaMin = 350;
  float altura;
  float yGlobal;
  float alphaGlobal, alphaGlobalR, alphaGlobalV;
  int elementos;
  float [] posY, ruidosY, varsY; // The positions that will change
  color c;
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
  // Constructors
  Ola() {
    this.elementos = int(random( elementosMin, elementosMax ));
    this.altura = random(alturaMin, alturaMax);
    this.yGlobal = random(height/4, height/4*3 +80);
    this.alphaGlobalR = random(0.00003,0.005);
    // We start the Arrays
    posY = new float[this.elementos];
    ruidosY = new float[this.elementos];
    varsY = new float[this.elementos];
    // We fill them
    for (int i = 0; i < this.elementos; i++) {
      posY[i] = 0.0; // Doesn't matter
      ruidosY[i] = random(ruidoMin, ruidoMax); // Different noises
      varsY[i] = random(ruidosY[i])*random(100,1000); // So they start at different times
    }
    String [] tipos = {
      "musicians", "technicians", "topics", "writers", "artists", "technicians"
    };
    c = obtenerColor(tipos[floor(random(tipos.length))]); // A random color
  }

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
  // Getters/Setters

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
  // Methods
  void mostrar() {
    // We calculate the positions
    calcularPosiciones();
    
    // We calculate global alpha animated
    alphaGlobalV += alphaGlobalR;
    alphaGlobal = noise(alphaGlobalV);

    // We begin creating the shape
    beginShape();
    fill(red(c), green(c), blue(c), 100 *alphaGlobal);
    noStroke();
    // Strating and ending X positions
    float inicioX = 0 -150; // Where does the graphic starts
    float finX = width+150;
    // Cycle for the vertex
    vertex( inicioX, 0 );
    for ( int i = 0; i < elementos; i++ ) {

      // We calculate the Y
      float y = yGlobal + map( posY[i], 0, 1, 0, -altura );

      // We calculate the X
      float x = map( i, 0, elementos, inicioX, finX );

      // We put a vertex
      //vertex( x, y );
      vertex( x, y );
    }
    vertex( finX, yGlobal );
    vertex( inicioX, yGlobal );
    endShape();
  }
  // 
  void calcularPosiciones() {
    // The usual Perlin Noise clich'e operations
    for ( int i = 0; i < elementos; i++ ) {
      varsY[i] += ruidosY[i];
      posY[i] = noise(varsY[i] );
    }
  }
}
