// ------------------------------------------------------------ \\
// ------------- s c e n a r i o s ---------------------------- \\
// ------------------------------------------------------------ \\
// This is the function that controls what is being visualize and what is not



String escenarioAnterior = "cover";
String escenarioActual = "cover"; // This will be the starting scenario BTW
String escenarioDeseado = "meh";
//
/// Starting variables for the Minority Report Scenario
String hugeMapMode = "MYtimes"; // Could be ----> "NYTimes" / "NGram"
String miniMapMode = "NGram"; // Could be ----> "NYTimes" / "NGram"
// "cover" "
// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ SHOW SCENARIOS

// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ 
void mostrarEscenarios() {

  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓  "cover" 
  // This is what we're supposed to see once we open the sketch
  if (escenarioActual == "cover") {
    cover();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓  "minority report"
  // The ever traditional FULL INFO scenario
  if (escenarioActual == "minority report") {
    // The values
    float margenD = 110;
    float margenI = 1;
    float margenTop = height*110/1050; 
    println("El display esta a : "+displayWidth+" x "+displayHeight);
    // The main Huge Graphic
    hugeMap(margenTop, margenTop, width-620.0, height/4*3.0 -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test
    // 
    float altoADistribuir = (height-(height-timeLineY)-margenTop)/2;
    float inicioVizD = width-540;
    // The mini Map
    //hugeMap(inicioVizD, margenTop, width-42, height/4*2.0 -150, "barras", true, "01101", true, "sinLeyenda", "miniMap" ); //NGram test
    hugeMap(inicioVizD, margenTop, width-42, margenTop+altoADistribuir -30, "barras", true, "01101", true, "sinLeyenda", "miniMap" ); //NGram test

    // The Tenori-ON option
    gridMap(inicioVizD, margenTop+altoADistribuir, width-42, margenTop+(altoADistribuir*2), "00001", true); // Writers only

    // We show the Lower tops rating
    lowerTops();

    // ]Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "full huge graph"
  if (escenarioActual == "full huge graph") {
    // 1. We specify the position 
    float margenDer = 40;
    // The main Huge Graphic
    // 
    //hugeMap(110.0, 110, width-110.0, height/4*3.0 -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test
    hugeMap(margenDer, 110, width-margenDer, height/4*3.0 -70, "barras", true, "11111", false, "conLeyenda", "hugeMap"); //NYTIMES test

    // We show the Lower tops rating
    lowerTops();

    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "tenori on"
  if (escenarioActual == "tenori on") {
    // 1. We specify the position 
    float margenDer = 20;
    float margenUp = 10;
    // The huge map
    if (width <= 1280) gridMap(margenDer, margenUp, width-margenDer, timeLineY-margenUp, "11111", false); // Huge Grid (FULLSCREEN all categories)
    if (width > 1280) gridMap(margenDer, margenUp, width-margenDer, timeLineY-margenUp, "11111", true); // Huge Grid (FULLSCREEN all categories)
    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "4 tops"
  if (escenarioActual == "4 tops") {
    // 1. We specify the position 
    float margenDer = 40;
    float margenTop = 90;
    float anchoTops = width-(margenDer*2);
    anchoTops /= 4;
    // 2. 
    topsMap( margenDer+(anchoTops*0), margenTop, margenDer+(anchoTops*0)+anchoTops, timeLineY-40, "artists", "·Artists·", artists);
    topsMap( margenDer+(anchoTops*1), margenTop, margenDer+(anchoTops*1)+anchoTops, timeLineY-40, "musicians", "·Musicians·", musicians);
    topsMap( margenDer+(anchoTops*2), margenTop, margenDer+(anchoTops*2)+anchoTops, timeLineY-40, "technicians", "·Technicians·", technicians);
    topsMap( margenDer+(anchoTops*3), margenTop, margenDer+(anchoTops*3)+anchoTops, timeLineY-40, "topics", "·Topics·", topics);

    // Navigation between scenarios
    mostrarNavegacion();

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "detail view"
  if (escenarioActual == "detail view") {
    // We shoe the detail view, almost fullscreen mode
    detailView(0, 0, width, timeLineY-(timeLineHeight/2));

    // Time line control and Viz Title
    timeLineAndTitle();
  }
  // ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓
}
// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ LOWER TERMS function
void lowerTops() {
  // Top terms at the bottom
  // 1. We specify the position 
  float margenDer = 40;
  float anchoTops = ((width/2) -margenDer -100)/2;
  // 2. 
  topsMap( margenDer, timeLineY+40, margenDer+anchoTops, timeLineY+40+150, "artists", "·Artists·", 3);
  topsMap( margenDer+anchoTops, timeLineY+40, margenDer+(anchoTops*2), timeLineY+40+150, "musicians", "·Musicians·", 3 );
  topsMap( width/2+120, timeLineY+40, (width/2+120)+(anchoTops*1), timeLineY+40+150, "technicians", "·Technicians·", 3);
  topsMap( width/2+120+anchoTops, timeLineY+40, (width/2+120)+(anchoTops*2), timeLineY+40+150, "topics", "·Topics·", 3);
}

// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ CHANGE A SCENARIO

void cambiarEscenario( String tipoNuevo) {
  // This function is activated when we change, like... setting the previous one and so forth.....

  // 1. We set the options for the new map
  if (tipoNuevo == "minority report") {
    hugeMapMode = "MYtimes"; // Could be ----> "NYTimes" / "NGram"
    miniMapMode = "NGram";
  }
  if ( tipoNuevo == "full huge graph") {
    hugeMapMode = "NGram"; // SO we see it googleStyle
    hugeMapMode = "both";
    zoomD = 1; // So we see it all
    timeLineCenterD = 1957;
  }
  if ( tipoNuevo == "detail view") {
    // We restart the fritcion values
    iniciarDetailViz();
  }

  // 2. We set the previous and the current one
  escenarioAnterior = escenarioActual; // This will help the 'back' functions
  escenarioActual = escenarioDeseado;
}
// █████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████ TRANSITION
Boolean enTransicion = false;
Boolean primeraVezTransicion = false;
Boolean segundaVezTransicion = false;
float opacidadActual = 0;
float opacidadD = 0;
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "ejecutar transition"
void ejecutarTransicion() {

  // So, this function will just make a fade function
  // 1. If this is the first time, we will set new opacity values --------------
  if (primeraVezTransicion) {
    opacidadD = 255;
    primeraVezTransicion = false; 
    segundaVezTransicion = false;
  }

  // 2. Now we will execute the friction values --------------------------------
  opacidadActual = calcularFriccion(opacidadActual, opacidadD, 6);

  // 3. We will draw the rectangle ---------------------------------------------
  noStroke();
  fill(red(azul3), green(azul3), blue(azul3), opacidadActual);
  // fill(red(blanco), green(blanco), blue(blanco), opacidadActual); // Flash blanco (just practice, not a game)
  shapeMode(CORNER);
  shape(Rect, 0, 0, width, height);

  // 4. We will ask if the growth is already there -----------------------------
  if (!segundaVezTransicion && opacidadActual >= 254) { // It means we are growing, adding up opacity
    opacidadActual = 255;
    opacidadD = 0;
    segundaVezTransicion = true;
    // We will trigger the stage changing here!
    cambiarEscenario(escenarioDeseado);
  }

  // 5. We will ask if the fade out is already there ---------------------------
  if (segundaVezTransicion && opacidadActual <= 0.01) {
    opacidadActual = 0;
    segundaVezTransicion = false;
    enTransicion = false;
  }
}
// ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ ▓ "start the transition"
void iniciarTransicion(String tipo) {
  // We set the file
  escenarioDeseado = tipo;
  // Transition global control values
  primeraVezTransicion = true;
  enTransicion = true; //
}
